<?php
// +---------------------------------------------------------------------------+
// | Geeklog 1.3 to Coppermine Photo Gallery 1.4 Bridge                        |
// +---------------------------------------------------------------------------+
// | geeklog.inc.php                                                           |
// |                                                                           |
// | Geeklog Bridge File.                                                      |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2005 by the following authors:                              |
// |                                                                           |
// | Authors: Michael Jervis - Mike AT fuckingbrit DOT com                     |
// | Based on phpbb22.inc.php by donnoman                                      |
// |                                                                           |
// | 03/07/2011 - Modified by Greg Gillis for use with Coppermine v1.5x        |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: $

//BEWARE - THIS BRIDGE WILL UNDO SOME OF THE SECURITY
//         PUT IN PLACE BY COPPERMINE'S INSPEKT.
//
//         USE AT YOUR OWN RISK
//
//undo the inspekt global killer before loading lib-common

    function cage_fighter() {
        $superCage = Inspekt::makeSuperCage();
        $_COOKIE=$superCage->cookie->_source;
        $_SERVER=$superCage->server->_source;
        $_ENV=$superCage->env->_source;
//        $_REQUEST=$_GET=$_POST=$_FILES=array();
    }
cage_fighter();

require_once('../lib-common.php');

global $_TABLES;

if (isset($bridge_lookup)) {
    $default_bridge_data[$bridge_lookup] = array(
        'full_name' => 'Geeklog v1.7x',
        'short_name' => 'geeklog',
        'support_url' => 'http://www.geeklog.net/',
        'full_forum_url_default' => 'http://www.yoursite.com',
        'full_forum_url_used' => 'mandatory,not_empty,no_trailing_slash',
        'relative_path_to_config_file_default' => '../../',
        'relative_path_to_config_file_used' => 'lookfor,config.php',
        'use_post_based_groups_default' => '0',
        'use_post_based_groups_used' => 'radio,1,0',
    );    
} else {

// Define the admin group for coppermine:
define('GL_UDB_ADMIN_GROUP', 101); // set to root...

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Switch that allows overriding the bridge manager with hard-coded values
define('USE_BRIDGEMGR', 1);

require_once('bridge/udb_base.inc.php');

class cpg_udb extends core_udb {
    var $groupscache;

	function cpg_udb()
	{
		global $BRIDGE, $_CONF, $_DB_host, $_DB_name, $_DB_user, $_DB_pass;
		global $_DB_table_prefix, $_TABLES;
		
		$this->boardurl = $_CONF['site_url'];
		
		// Database connection settings
		$this->db = array(
			'name' => $_DB_name,
			'host' => $_DB_host ? $_DB_host : 'localhost',
			'user' => $_DB_user,
			'password' => $_DB_pass,
			'prefix' => $_DB_table_prefix
		);
		
		// Board table names
		$this->table = array(
			'users' => 'users',
			'groups' => 'groups',
			'sessions' => 'sessions'
		);

		// Derived full table names
		$this->usertable = '`' . $this->db['name'] . '`.' . $_TABLES['users'];
		$this->groupstable =  '`' . $this->db['name'] . '`.' . $_TABLES['groups'];
		$this->sessionstable =  '`' . $this->db['name'] . '`.' . $_TABLES['sessions'];
		
		// Table field names
		$this->field = array(
			'username' => 'username', // name of 'username' field in users table
			'user_id' => 'uid', // name of 'id' field in users table
			'password' => 'passwd', // name of 'password' field in users table
			'email' => 'email', // name of 'email' field in users table
			'regdate' => 'regdate', // name of 'registered' field in users table
			'active' => 'status', // is user account active?
			'lastvisit' => "''", // name of 'location' field in users table
			'location' => "''", // name of 'location' field in users table
			'website' => 'homepage', // name of 'website' field in users table
			'usertbl_group_id' => "''", // name of 'group id' field in users table
			'grouptbl_group_id' => 'grp_id', // name of 'group id' field in groups table
			'grouptbl_group_name' => 'grp_name' // name of 'group name' field in groups table
		);
		
		// Pages to redirect to
		$this->page = array(
			'register' => $_CONF['site_admin_url'].'/users.php?mode=new',
			'editusers' => $_CONF['site_admin_url'].'/user.php',
			'edituserprofile' => $_CONF['site_admin_url'].'/user.php?mode=edit&uid=',
		);

		// Group ids
		$this->admingroups = array(GL_UDB_ADMIN_GROUP);
		$this->guestgroup = 2;
		$this->use_post_based_groups = true;
		
		// Cookie settings - used in following functions only
		$this->cookie_name = $BRIDGE['cookie_prefix'];
		$this->cookie_seed = '';
		
		// Connect to db
		$this->connect();
	}
	
	function authenticate()
	{
		global $USER_DATA;
        
        $_USER = SESS_sessionCheck();
		if ( empty( $_USER['uid'] ) || ( $_USER['uid'] == 1 )) {
			$this->load_guest_data();
		} else {
			// Get user groups
			$this->get_groups($_USER['uid']);
			$USER_DATA['groups'] = $this->groupscache;
			$USER_DATA['user_id'] = $_USER['uid'];
			$USER_DATA['user_name'] = COM_getDisplayName($_USER['uid']);
		}

        $USER_DATA = array_merge($USER_DATA, $this->get_user_data($USER_DATA['groups'][0], $USER_DATA['groups'], $this->guestgroup));

        if (in_array(GL_UDB_ADMIN_GROUP, $USER_DATA['groups']))
        {
			$USER_DATA['has_admin_access'] = 1;
		} else {
			$USER_DATA['has_admin_access'] = 0;
		}
		
		$USER_DATA['can_see_all_albums'] = $USER_DATA['has_admin_access'];
		
		// avoids a template error
		if (!$USER_DATA['user_id']) $USER_DATA['can_create_albums'] = 0;
		
	    // For error checking
		$CONFIG['TABLE_USERS'] = '**ERROR**';
		$user_group_set = '(' . implode(',', $USER_DATA['groups']) . ')';
		define('USER_ID', $USER_DATA['user_id']);
        define('USER_NAME', addslashes($USER_DATA['user_name']));
        define('USER_GROUP', $USER_DATA['group_name']);
        define('USER_GROUP_SET', $user_group_set);
        define('USER_IS_ADMIN', $USER_DATA['has_admin_access']);
        define('USER_CAN_SEND_ECARDS', (int)$USER_DATA['can_send_ecards']);
        define('USER_CAN_RATE_PICTURES', (int)$USER_DATA['can_rate_pictures']);
        define('USER_CAN_POST_COMMENTS', (int)$USER_DATA['can_post_comments']);
        define('USER_CAN_UPLOAD_PICTURES', (int)$USER_DATA['can_upload_pictures']);
        define('USER_CAN_CREATE_ALBUMS', (int)$USER_DATA['can_create_albums']);
        define('USER_UPLOAD_FORM', (int)$USER_DATA['upload_form_config']);
        define('CUSTOMIZE_UPLOAD_FORM', (int)$USER_DATA['custom_user_upload']);
        define('NUM_FILE_BOXES', (int)$USER_DATA['num_file_upload']);
        define('NUM_URI_BOXES', (int)$USER_DATA['num_URI_upload']);
		define('USER_ACCESS_LEVEL', (int)$USER_DATA['access_level']);				
	}

	// definition of actions required to convert a password from user database form to cookie form
	function udb_hash_db($password)
	{
		return $password; // unused
	}
	
	function login_page()
	{
	    global $_CONF;
		$this->redirect($_CONF['site_url'].'/users.php');
	}

	function logout_page()
	{
	    global $_CONF;
		$this->redirect($_CONF['site_url'].'/users.php?mode=logout');
	}

    function get_groups($uid)
    {
        if (is_array($this->groupscache))
        {
            return $this->groupscache;
        } else {
            $groups = SEC_getUserGroups($uid);
            $this->groupscache = array();
            foreach($groups as $key => $value)
            {
                // Coppermine requires an offset of 100, gay.
                $this->groupscache[] = $value + 100;
            }
            return $this->groupscache;
        }
    }
    
    	// Retrieve the name of a user
	function get_user_name($uid)
	{
		return COM_getDisplayName($uid);
	}
	
	function load_guest_data()
	{
		global $USER_DATA, $LANG01;

		$USER_DATA['user_id'] = 0;
        $USER_DATA['user_name'] = $LANG01[24];
        $USER_DATA['groups'][0] = $this->use_post_based_groups ? ($this->guestgroup) + 100 : 3;
        $USER_DATA['group_quota'] = 1;
        $USER_DATA['can_rate_pictures'] = 0;
		$USER_DATA['can_send_ecards'] = 0;
		$USER_DATA['can_post_comments'] = 0;
		$USER_DATA['can_upload_pictures'] = 0;
		$USER_DATA['can_create_albums'] = 0;
		$USER_DATA['pub_upl_need_approval'] = 1;
		$USER_DATA['priv_upl_need_approval'] = 1;
		$USER_DATA['upload_form_config'] = 0;
		$USER_DATA['num_file_upload'] = 0;
		$USER_DATA['num_URI_upload'] = 0;
		$USER_DATA['custom_user_upload'] = 0;
	}
		
	// Get user information
	function get_user_infos($uid)
	{
        global $lang_register_php, $_TABLES;

		$sql = 'SELECT username,fullname,remoteusername,remoteservice '
		        .'email as user_email, '
		        .'regdate as user_regdate, '
		        .'homepage as user_website, '
		        .'location as user_location '
		        ."FROM {$_TABLES['userinfo']}, {$_TABLES['users']} WHERE "
		        ."{$_TABLES['userinfo']}.uid = {$_TABLES['users']}.uid AND "
		        ."{$_TABLES['users']}.uid = $user";
    
		$result = cpg_db_query($sql, $this->link_id);
		
		if (!mysql_num_rows($result)) cpg_die(ERROR, $lang_register_php['err_unk_user'], __FILE__, __LINE__);

		$user_data = mysql_fetch_array($result);
		$user_data['user_name'] = COM_displayName($uid, $user_data['username'], $user_data['fullname'], $user_data['remoteusername'], $user_data['remoteservice']);
		$user_data['group_name'] = '';
		mysql_free_result($result);

		return $user_data;
	}
	
    // Redirect
	function redirect($target)
	{
		header('Location: '. $target);
		exit;
	}
}

// and go !
$cpg_udb = new cpg_udb;
}
?>
