<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | SocialShare Plugin 1.2                                                    |
// +---------------------------------------------------------------------------+
// | english.php                                                               |
// |                                                                           |
// | English language file                                                     |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009-2011 by the following authors:                         |
// |                                                                           |
// | Authors: Greg Gillis - greg DOT gillis AT sillig DOT com                  |
// +---------------------------------------------------------------------------+
// | Created with the Geeklog Plugin Toolkit.                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package SocialShare
*/

/**
* Import Geeklog plugin messages for reuse
*
* @global array $LANG32
*/
global $LANG32;

// +---------------------------------------------------------------------------+
// | Array Format:                                                             |
// | $LANGXX[YY]:  $LANG - variable name                                       |
// |               XX    - specific array name                                 |
// |               YY    - phrase id or number                                 |
// +---------------------------------------------------------------------------+

$LANG_SOCIALSHARE_0 = array(
    1 => 'SocialShare Editor',
    2 => 'Enabled',
    3 => 'Save',
    4 => 'Cancel',
    5 => 'Share URL',
    6 => 'Share Image',
    7 => 'Share Icon',
    8 => 'Delete',
    9 => 'Do you really want to delete this item?',
    10 => 'To modify or delete a Share item, click on that Share item\'s edit icon below.  To create a new Share item, click on "Create New" above. To move a Share item, click on the arrows.',
    11 => 'SocialShare Manager',
    12 => 'Your Share Title must not be empty and cannot contain HTML!',
    13 => 'Bad Share Title',
    14 => '<b>Share</b>',
    15 => 'The selected Share site has been deleted',
    16 => 'Your Share site has been successfully saved.',	
    17 => 'SocialShare',
    18 => 'Share URL',
    19 => 'Title',
    20 => 'Icon',
    21 => 'Enabled',
    22 => 'Edit',
    23 => 'Owner',
    24 => 'Order',
    25 => 'Move Item Left',
    26 => 'Move Item Right',
    27 => 'Move'	
);


// Messages for the plugin upgrade
$PLG_socialshare_MESSAGE3002 = $LANG32[9]; // "requires a newer version of Geeklog"


?>
